View Issue Details

IDProjectCategoryView StatusLast Update
0001413Wishes.PluginsHlfViewerpublic2013-04-23 09:38
ReporterJohnDoe Assigned Tovskirdin  
PrioritynormalSeverityfeatureReproducibilityN/A
Status closedResolutionfixed 
Fixed in Version3.0 
Summary0001413: hlf:%farhome%\filename [topic]
Description1. Научить плагин искать указанный в командной строке hlf-файл в директории фара и плагинов.
2. Разворачивать переменные окружения.
3. Понимать название топика указанное вместе с @
Additional Information(1)
Хотелось бы независимо от текущей директории иметь возможность просто указать в командной строке имя файла, без пути:

hlf:FarRus.hlf About
hlf:FARCmdsRus.hlf Config

Это было бы очень полезно для указания конкретного места в хелпе, например, по чьему-то запросу на форуме.

(2)
Если для хелпов плагинов это реализовать проблематично, тогда можно хотя бы научить понимать переменные окружения, либо просто искать относительно %FARHOME%:

hlf:%FARHOME%\plugins\farcmds\FarRus.hlf About

Учитывая отсутствие поиска по справке предлагаемые улучшения плагина представляются совсем не лишними.

(3)
Мелочь, но удобно было бы если бы плагин понимал указание топика с символом @:

hlf:FarRus.hlf @About

(Периодически забываю что надо без собаки)
TagsNo tags attached.

Activities

vskirdin

2012-07-25 07:55

administrator   bugnote:0009432

пробуй: http://skirda-file.googlecode.com/files/hlfviewer.38.1.7z

JohnDoe

2012-08-04 19:01

updater   bugnote:0009454

В ответ на hlf:FarRus.hlf About

╔════════════════════ Access denied ═════════════════════╗
║ You need to provide administrator permission ║
║ to open this object: ║
║ E.BIN\S-1-5-21-3143715236-3382279602-1299255314-1002\ ║
║ ║
║ [x] Do this for all current objects ║
║ [ ] Do not ask again in the current session ║
╟────────────────────────────────────────────────────────╢
║ { ▀▄ OK } [ Skip ] ║
╚════════════════════════════════════════════════════════╝

Жму Skip - и тогда уже открывается справка, как и надо.

JohnDoe

2012-08-04 19:14

updater   bugnote:0009455

Такое вылазит если текущая папка - корень диска.
Похоже плагин делает полный перебор подпапок...
А если указать несуществующее имя, то зависает о-очень надолго.

vskirdin

2012-08-05 14:28

administrator   bugnote:0009456

и?

JohnDoe

2012-08-06 09:03

updater   bugnote:0009457

1. Зачем вообще искать относительно ТЕКУЩЕЙ папки?
2. Если нет прав, то лучше молча пропускать.
3. Плохо что длительная операция никак не индицируется.
И мне даже прервать её не удалось.

vskirdin

2013-04-15 11:17

administrator   bugnote:0010782

Как на счет решения этого Инца по следующему плану:
1. '@' - корректируем, если в топике первым символом идет собака. Это позволит так же писать "hlf:FarRus.hlf @About".
2. Учимся понимать переменные окружения.
3. Добавляется возможность указать вместо имени hlf-файла его GUID

Т.е., что получаем:
1. Нужен конкретный хелп-файл (даже, если "этот" плагин не в "этой сессии" Far) - указываем путь
2. hlf:{GUID} [Topic] - даст тему по правилам флага FHELP_CUSTOMPATH ( http://api.farmanager.com/ru/service_functions/showhelp.html#FHELP_CUSTOMPATH )

vskirdin

2013-04-16 13:11

administrator   bugnote:0010800

build 45

   a) Если указан "файл" без пути, то порядок следущий:
       1) GUID
       2) Текущий каталог
       3) %FARHOME%
       4) по путям плагинов, сидящих "в этой сессии" Far Manager

   b) В редакторе не смотрим на маску файла *.hlf, только по признакам:
       1) первая строка файла равна ".Language="
       2) наличие любого вхождения последовательности "@букво-цифры", не содержащее символ "="

      Т.е. теперь можно смотреть "Far*.hlf.m4" :-)
        правда некоторые темы будут некорректно отображаться из-за наличия m4-макросов.

   c) добавлена опция про маски файлов помощи.

   d) Макросы: только в редакторе.
      Plugin.Call("1AF0754D-5020-49cb-9474-1F82691C84C1")
      вызывает тему помощи, как будто плагин перехватил F1 в текущей сессии редактора.

   1. '@' - корректируем, если в топике первым символом идет собака. Это позволит так же писать "hlf:FarRus.hlf @About".
   2. Учимся понимать переменные окружения.
   3. Добавляется возможность указать вместо имени hlf-файла GUID-соответствующего плагина

vskirdin

2013-04-20 12:18

administrator   bugnote:0010868

Last edited: 2013-04-20 12:18

View 2 revisions

Удовлетворение полное?
Закрываем?

JohnDoe

2013-04-20 14:02

updater   bugnote:0010870

a) 4) работают маски ))

с) ограничение по маске не работает
Проверить можно на lng-файлах
(В панели это ограничение и не нужно, имя ведь явно указано)

d) побочный эффект: вызов из панелей тоже сработает, если в фоне есть открытый редактор (не проблема)

JohnDoe

2013-04-20 14:08

updater   bugnote:0010871

Last edited: 2013-04-20 14:09

View 2 revisions

Выбор клавиши в настройках - избыточная функциональность

"Опция Проверять по маске файлов [...] По умолчанию опция отключена"
По-умолчанию лучше включить


Опечатки в хелпе:
Гуид в смешанном регистре (то же в changelog)

"кроме маски так же проверят содерджимое файла на наличие ключевых компонентов hfl"
проверят=проверяет
содерджимое=содержимое
hfl=hlf

vskirdin

2013-04-22 08:18

administrator   bugnote:0010877

build 47

vskirdin

2013-04-23 09:38

administrator   bugnote:0010881

build 48

Issue History

Date Modified Username Field Change
2010-06-17 15:50 JohnDoe New Issue
2012-07-25 07:55 vskirdin Note Added: 0009432
2012-08-04 19:01 JohnDoe Note Added: 0009454
2012-08-04 19:14 JohnDoe Note Added: 0009455
2012-08-05 14:28 vskirdin Note Added: 0009456
2012-08-06 09:03 JohnDoe Note Added: 0009457
2013-04-15 11:17 vskirdin Note Added: 0010782
2013-04-16 13:11 vskirdin Note Added: 0010800
2013-04-16 13:11 vskirdin Assigned To => vskirdin
2013-04-16 13:11 vskirdin Status new => feedback
2013-04-20 12:18 vskirdin Note Added: 0010868
2013-04-20 12:18 vskirdin Note Edited: 0010868 View Revisions
2013-04-20 14:02 JohnDoe Note Added: 0010870
2013-04-20 14:02 JohnDoe Status feedback => assigned
2013-04-20 14:08 JohnDoe Note Added: 0010871
2013-04-20 14:09 JohnDoe Note Edited: 0010871 View Revisions
2013-04-22 08:18 vskirdin Note Added: 0010877
2013-04-22 08:18 vskirdin Status assigned => feedback
2013-04-23 09:35 JohnDoe Status feedback => resolved
2013-04-23 09:38 vskirdin Note Added: 0010881
2013-04-23 09:38 vskirdin Status resolved => closed
2013-04-23 09:38 vskirdin Resolution open => fixed
2013-04-23 09:38 vskirdin Fixed in Version => 3.0